var mongoose = require('mongoose');
var encrypt = require('./index.js');

var userSchema = new mongoose.Schema({
	field1: String,
	field2: Number
	// whatever else
});

userSchema.plugin(encrypt, { key: 'Some32ByteBase64String/ButDontUseThisOnePlx', fields: ['field1', 'field2'] });

// This adds a _ct field to the schema, as well as pre 'init' and pre 'save' middleware, and encrypt and decrypt instance methods

User = mongoose.model('User', userSchema);

joe = new User ({field1: 'something', field2: 42});
joe.encrypt(function(err){
	if (err) return handleError(err);
	console.log(joe.field1); // undefined
	console.log(joe.field2); // undefined
	console.log(joe._ct); // <Buffer 4a 89 9e df 60 ...

	joe.decrypt(function(err){
		if (err) return handleError(err);
		console.log(joe.field1); // 'something'
		console.log(joe.field2); // 42
		console.log(joe._ct); // undefined
	});
});
